/*
 * File         : ClientHandler.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:29 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __CLIENTHANDLER_H )
#define __CLIENTHANDLER_H

#include "DSSingletons.h"

#include <ace/Svc_Handler.h>
#include <ace/SOCK_Stream.h>

class ActiveUser;

class ClientHandler
: public ACE_Svc_Handler<ACE_SOCK_STREAM, ACE_NULL_SYNCH>
{
public:
	ClientHandler() : user_( 0 ), msg_( 0 ), msg_mb_( 0 ), svc_mb_( 0 ) {}
	int open( void* );
	
protected:
	int handle_input( ACE_HANDLE );
	int handle_close( ACE_HANDLE, ACE_Reactor_Mask );

private:
	ActiveUser* user_;
	DSMessage* msg_;
	ACE_Message_Block* msg_mb_;
	ACE_Message_Block* svc_mb_;
};

#endif
