/*
 * File         : Conference.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 29 16:45:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/03/13 00:01:14 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __CONFERENCE_H )
#define __CONFERENCE_H

#include <ace/SString.h>

class Participant;

class Conference
{
public:
	typedef ACE_CString CharString;
	typedef u_long ConferenceKey;
	typedef u_long ParticipantKey;
	typedef char*& KeyVector;

	Conference() : closed_( false ), public_( true ) {}
	virtual ~Conference() {}
	virtual int open( void* = 0, size_t = 0 )=0;
	virtual int close( void* = 0, size_t = 0 )=0;
	virtual int join( Participant* )=0;
	virtual int leave( Participant* )=0;
	virtual int set_chair( Participant* )=0;
	virtual unsigned int cur_num_part()=0;
	virtual unsigned int max_num_part()=0;
	virtual int build_key_vector( KeyVector )=0;
	void set_topic( const char* topic ) { topic_ = topic; }
	bool is_public() const { return public_; }
	bool is_closed() const { return closed_; }
	ConferenceKey key() { return ( ConferenceKey )this; }

protected:
	CharString topic_;
	bool public_;
	bool closed_;
};

#endif
