/*
 * File         : DSHashMapManager.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Feb 20 12:06:26 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/28 00:57:30 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __DSHASHMAPMANAGER_H )
#define __DSHASHMAPMANAGER_H

#include <ace/Hash_Map_Manager.h>

template<class DSKey, class DSEntry> class DSHashMapIterator;

template<class DSKey, class DSEntry>
class DSHashMapManager
: public ACE_Hash_Map_Manager<DSKey, DSEntry, ACE_RW_Thread_Mutex>
{
	friend class DSHashMapIterator<DSKey, DSEntry>;

public:
	int find( const DSKey& ext_id, DSEntry& int_id ) { return this->find_i( ext_id, int_id ); }
};

template<class DSKey, class DSEntry>
class DSHashMapIterator
: public ACE_Hash_Map_Iterator<DSKey, DSEntry, ACE_RW_Thread_Mutex>
{
public:
	DSHashMapIterator( DSHashMapManager<DSKey, DSEntry>& mm, int tail = 0 )
		: ACE_Hash_Map_Iterator<DSKey, DSEntry, ACE_RW_Thread_Mutex>( mm, tail )
	{}

	int acquire_read() { return ( ( DSHashMapManager<DSKey, DSEntry>* )map_man_ )->lock_.acquire_read(); }
	int release() { return ( ( DSHashMapManager<DSKey, DSEntry>* )map_man_ )->lock_.release(); }
};

#endif
