/*
 * File         : DSSingletons.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:30 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __DSSINGLETONS_H )
#define __DSSINGLETONS_H

#include "ThreadPool.h"
#include "ProtocolInterface.h"
#include "MsgFlyweight.h"
#include "Message.h"
#include "MsgHeader.h"

#include <ace/Singleton.h>
#include <ace/SOCK_Stream.h>

typedef MsgHeader<ACE_SOCK_Stream> DSMsgHeader;
typedef Message<DSMsgHeader> DSMessage;
typedef MsgFlyweight<DSMessage::MID, DSMessage*> DSMsgFlyweight;
typedef ProtocolInterface<DSMessage, DSMsgFlyweight> DSProtocol;
typedef ACE_Singleton<DSProtocol, ACE_Null_Mutex> SDSProtocol;
typedef ACE_Singleton<DSMsgFlyweight, ACE_Null_Mutex> SDSMsgFlyweight;
typedef ACE_Singleton<ThreadPool, ACE_Null_Mutex> SDSThreadPool;

#endif
