/*
 * File         : DirServer.cpp
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:33 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "DirectoryService.h"

#include <ace/Service_Config.h>

ACE_STATIC_SVC_REQUIRE(DirectoryService)

ofstream log;

int
main( int argc, char* argv[] )
{
#if !defined( ACE_NDEBUG )
	char* log_dir;
	if( log_dir = getenv( "DS_LOG_DIR" ) )
	{
		const int CF_MODE = 0666;
		const char* LOG_PREFIX = "DS_";
		char* tempfile = tempnam( log_dir, LOG_PREFIX );
		char* logfile = new char[strlen( tempfile ) + 5 ];
		if( logfile )
		{
			strcpy( logfile, tempfile );
			strcat( logfile, ".log" );
			log.open( logfile );
			delete logfile;
			if( log )
			{
				chmod( logfile, CF_MODE );
				ACE_LOG_MSG->set_flags( ACE_Log_Msg::OSTREAM );
				ACE_LOG_MSG->msg_ostream( &log );
				ACE_LOG_MSG->clr_flags( ACE_Log_Msg::STDERR );
				ACE_LOG_MSG->start_tracing();
			}
			else
				cerr << "Cannot open " << tempfile << endl;
		}
		else
			cerr << "Cannot allocate memory for log filename\n";
	}
	else
		cerr << "Cannot find DS_LOG_DIR\n";
#endif

	if( ACE_Service_Config::open( argc, argv ) == -1 )
		ACE_ERROR_RETURN(( LM_ERROR, "%p\n", "open" ), 1);

//	Create an adapter to end the event loop.
//  ACE_Sig_Adapter sa ((ACE_Sig_Handler_Ex) ACE_Reactor::end_event_loop);

//  ACE_Sig_Set sig_set;
//  sig_set.sig_add (SIGINT);
//  sig_set.sig_add (SIGQUIT);

//	Register ourselves to receive signals so we can shut down
//	gracefully.
//  if (ACE_Reactor::instance ()->register_handler (sig_set, &sa) == -1)
//		ACE_ERROR_RETURN ((LM_ERROR, "%p\n"), -1);

	ACE_Reactor::run_event_loop ();

//	ACE_Reactor::instance()->close();
//	ACE_Thread_Manager::instance()->wait();
//	ACE_Service_Config::close_singletons();
	return 0;
}
