/*
 * File         : DirectoryService.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:34 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include <ace/Acceptor.h>
#include <ace/SOCK_Acceptor.h>
#include <ace/Service_Config.h>

#include "ClientHandler.h"

class DirectoryService
: public ACE_Service_Object
{
public:
	typedef ACE_Acceptor<ClientHandler, ACE_SOCK_ACCEPTOR> DSClientAcceptor;

	DirectoryService();
	~DirectoryService();

	int init( int argc, char* argv[] );
	int fini();

private:

	int parse_args( int argc, char* argv[] );

	DSClientAcceptor acceptor_;
	unsigned short port_;
	unsigned short threads_;
};

inline DirectoryService::
DirectoryService()
: port_( 4401 ), threads_( 5 )
{
	ACE_TRACE( "(DirectoryService::DirectoryService)" );
}

inline DirectoryService::
~DirectoryService()
{
	ACE_TRACE( "(DirectoryService::~DirectoryService)" );
	ACE_DEBUG(( LM_DEBUG, "deleting Directory Service\n" ));
}

ACE_STATIC_SVC_DECLARE(DirectoryService)
