/*
 * File         : Message.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:34 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined(__MESSAGE_H)
#define __MESSAGE_H

class ActiveUser;

template<class HEADER>
class Message
{
public:
	typedef HEADER Header;
	typedef HEADER::SAP SAP;
	typedef HEADER::MID MID;

	Message( const HEADER& h ) : header_( h ), user_( 0 )
		{ ACE_DEBUG(( LM_DEBUG, "(%t) creating msg: 0x%x\n", this )); }

	virtual ~Message()
		{ ACE_DEBUG(( LM_DEBUG, "(%t) deleting msg: 0x%x, user: 0x%x\n", this, user_ )); }

	virtual int recv( SAP&, HEADER& )=0;
	virtual int send( SAP& )=0;
	virtual int set( void*, size_t = 0 )=0;
	virtual int execute()=0;
	virtual Message<HEADER>* clone()=0;
	void user( ActiveUser* au ) { user_ = au; }

protected:
	Header header_;
	ActiveUser* user_;
};

#endif
