/*
 * File         : Participant.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 29 16:50:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/03/13 00:01:19 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __PARTICIPANT_H )
#define __PARTICIPANT_H

#include "Conference.h"
#include "DSSingletons.h"
#include "DirectoryProtocol.h"

class Participant
{
public:
	typedef u_long ParticipantKey;

	Participant() : conf_( 0 ) {}
	virtual ~Participant() {}
	virtual ParticipantKey key()=0;
	virtual int send( DSMessage* msg )=0;
	virtual int bcast( DSMessage* msg )=0;
	virtual	int send_msg( DirectoryProtocol::ProtoCode, void*, size_t = 0 )=0;
	virtual int bcast_msg( DirectoryProtocol::ProtoCode, void*, size_t = 0 )=0;
	void conf( Conference* new_conf ) { conf_ = new_conf; }
	Conference* conf() const { return conf_; }
	
protected:
	Conference* conf_;
};

#endif
