/*
 * File         : ParticipantRep.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Feb 20 19:06:26 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/02/28 00:57:36 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __PARTICIPANTREP_H )
#define __PARTICIPANTREP_H

#include <vector>

#if defined( _WIN32 )
using namespace std;
#endif

template<class T>
class Linkable
{
public:
	Linkable( const T& payload ) { payload_ = &payload; }
	Linkable( T* payload = 0 ) { payload_ = payload; }
	Linkable* get_next() const { return next_; }
	void set_next( Linkable* next ) { next_ = next; }
	T* operator->() const { return payload_; }

protected:
	Linkable* next_;
	T* payload_;
};

class Participant;

typedef Participant* ParticipantEnt;
typedef vector<ParticipantEnt> DSParticipantRep;

#endif
