/*
 * File         : RefImpl.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Feb 09 10:46:26 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/02/28 00:57:36 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __REFIMPL_H )
#define __REFIMPL_H

class RefImpl
{
public:
	RefImpl() : ref_counter_( 0 ) {}
	~RefImpl() { ACE_DEBUG(( LM_DEBUG, "(%t) Deleting RefImpl: 0x%x\n", this )); }
	int addRef() { return ++ref_counter_; }
	int release() { int count = --ref_counter_; if( count == 0 ) delete this; return count; }

private:
	unsigned int ref_counter_;
};

#endif