/*
 * File         : SPtrImpl.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Feb 09 10:46:26 1998
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/02/28 00:57:37 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __SPTRIMPL_H )
#define __SPTRIMPL_H

template<class T>
class SPtrImpl
{
public:
	SPtrImpl( T* ptr = 0 ) : ptr_( ptr ) { if( ptr_ ) ptr_->addRef(); }
	SPtrImpl( const SPtrImpl& sptr ) : ptr_( sptr.ptr_ ) { if( ptr_ ) ptr_->addRef(); }
	~SPtrImpl() { ptr_->release(); ptr_ = 0; }
	T* operator->() { return ptr_; }
	SPtrImpl& operator=( const SPtrImpl& sptr )
	{
		ptr_->release();
		ptr_ = sptr.ptr_;
		if( ptr_ ) ptr_->addRef();
		return *this;
	}

private:
	T* ptr_;
};

#endif