/*
 * File         : ThreadPool.cpp
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:37 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "ThreadPool.h"
#include "ActiveUser.h"
#include "DSSingletons.h"

extern ofstream log;

int ThreadPool::
svc()
{
#if !defined( ACE_NDEBUG )
	if( log )
	{
		ACE_LOG_MSG->set_flags( ACE_Log_Msg::OSTREAM );
		ACE_LOG_MSG->msg_ostream( &log );
		ACE_LOG_MSG->clr_flags( ACE_Log_Msg::STDERR );
		ACE_LOG_MSG->start_tracing();
	}
#endif
	ACE_TRACE( "(ThreadPool::svc)" );
	ACE_Message_Block* mb;
	ActiveUser* user;
	int result;
	for( ; ; )
	{
		getq( mb );
		user = ( ActiveUser* )mb->rd_ptr();
		ACE_DEBUG(( LM_DEBUG, "(%t) (ThreadPool::svc) getting request from user: 0x%x \n", user ));
		mb->release();
		result = user->service();
		ACE_DEBUG(( LM_DEBUG, "(%t) (ThreadPool::svc) serviced user: 0x%x, result: %s\n",
					user, ( result == 0 ) ? "OK" : "Error!" ));
	}
	return 0;
}
