/*
 * File         : ThreadPool.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 28 18:06:26 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/02/28 00:57:37 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __THREADPOOL_H )
#define __THREADPOOL_H

#include <ace/Task.h>

class ThreadPool
: public ACE_Task<ACE_MT_SYNCH>
{
public:
	int open( int n_threads );
	int svc();
};

inline int ThreadPool::
open( int n_threads )
{
	if( activate( THR_NEW_LWP, n_threads ) == -1 )
		ACE_ERROR_RETURN(( LM_ERROR, "%p\n", "activate" ), -1 );

	return 0;
}

#endif
