/*
 * File         : UserInfo.h
 * Author       : Pawel Roman (proman@npac.syr.edu)
 * Created      : Wed Jan 29 18:00:26 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/02/28 00:57:38 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#if !defined( __USERINFO_H )
#define __USERINFO_H

#include <ace/SString.h>

class UserInfo
{
public:
	typedef ACE_CString CharString;

	UserInfo( const CharString& fn, const CharString& ln, const CharString& em );
	const char* first_name() const { return first_name_.c_str(); }
	const char* last_name() const { return last_name_.c_str(); }
	const char* email() const { return email_.c_str(); }

private:
	CharString first_name_;
	CharString last_name_;
	CharString email_;
};

inline UserInfo::
UserInfo( const CharString& fn, const CharString& ln, const CharString& em )
: first_name_( fn ), last_name_( ln ), email_( em )
{
	ACE_DEBUG(( LM_DEBUG, "(%t) First Name: %s, Last Name: %s, E-mail: %s\n",
				first_name_.c_str(), last_name_.c_str(), email_.c_str() ));
}

#endif
